/* #-#   Fichier bonjourC.c issu de galg -a bonjourC.alg -o c */
/* #-#  ===================================================== */
/* #-#      19/09/2001 12:16.52 */

/* ############################################################### */
/*                                                               # */
/*                                                               # */
/*   auteur : (gH)                                               # */
/*   bonjour.alg : un algorithme de bonjour consquent.          # */
/*                                                               # */
/*                                                               # */
/* ############################################################### */
/*                                                               # */
/*                                                               # */
/*                                                               # */
/*       cet algorithme comporte un dialogue o on demande      # */
/*       l'utilisateur de donner son nom ;                       # */
/*       il affiche ensuite la date et l'heure puis dit au       # */
/*       revoir  la personne aprs avoir le nom en majuscules.  # */
/*                                                               # */
/*                                                               # */
/*                                                               # */
/* ############################################################### */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de maju.c via le code #>  */

char*  maju(chaine f_iden) {
 int idc = 0 ;
 while (idc<strlen(f_iden)) {
    f_iden[idc] = toupper(f_iden[idc]) ;
    idc++ ;
 } ; /* fin de pour # idc */
 return( f_iden ) ;
} /* fin de maju */


/* #-#  Fin d'ajout de maju.c via le code #>  */
/* #-#  Ajout de date.c via le code #>  */


char* date(void) {
     time_t now   = time(NULL);
     struct tm *t = localtime(&now);
     char laDate[100] ;
     strftime(laDate, 100, "%d/%m/%Y", t) ;
     return(laDate) ;
} /* fin de date */

/* #-#  Fin d'ajout de date.c via le code #>  */
/* #-#  Ajout de heure.c via le code #>  */

char* heure(void) {
     time_t now   = time(NULL);
     struct tm *t = localtime(&now);
     char lHeure[100];
     strftime (lHeure, 100, "%H:%M.%S", t);
     return(lHeure) ;
} /* fin de heure */

/* #-#  Fin d'ajout de heure.c via le code #>  */

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int main() {

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
chaine id ;

   /*  la demande = une question + une rponse */

   printf("%s"," Bonjour. Quel est ton nom ? ") ;
puts("") ;

   fgets(id,250,stdin) ;


   /*  ce qu'on fait rpondre par la machine */

   printf("%s"," Le ") ;
printf("%s",date()) ;
printf("%s","  ") ;
printf("%s",heure()) ;
printf("%s"," au revoir ") ;
printf("%s",maju(id)) ;
puts("") ;

return(0);
} /* fin de main */ 

/* #-#   Fin de traduction pour bonjourC.c via de galg -a bonjourC.alg -o c */
