// ##-#   Fichier macndb.prg issu de galg -a macndb.alg -o dbase
// ##-#  =======================================================
// ##-#      02/08/2001 15:23.14

// ##############################################################
// #                                                            #
// #   macNaughton.alg : affectation de taches selon            #
// #                   la mthode de mac Naughton               #
// #   auteur (gH)                                              #
// #                                                            #
// #                                                            #
// ##############################################################
// #                                                            #
// #   rfrences ???                                           #
// #                                                            #
// #                                                            #
// ##############################################################
// #                                                            #
// #                                                            #
// # avec nbMachines qui doivent effectuer nbTaches et sachant  #
// # que la tache numro i dure dureeTache[ i] comment rpartir #
// # les taches ? la dure est en heure et les taches sont      #
// # morcelables heure par heure.                               #
// #                                                            #
// #                                                            #
// ##############################################################

// # 0.  Affectations arbitraires pour tester l'exemple fourni
// #     dans le cours vu sur le web  l'adresse


store 3 to nbMachines 
store 6 to nbTaches 

// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare dureeTache [ nbTaches ]

store 5 to dureeTache[ 1 ] 
store 3 to dureeTache[ 2 ] 
store 4 to dureeTache[ 3 ] 
store 5 to dureeTache[ 4 ] 
store 2 to dureeTache[ 5 ] 
store 5 to dureeTache[ 6 ] 


// # 1. Calcul de la dure minimale

store 0 to somDuree 
for indTache := 1 to nbTaches 
     store dureeTache[ indTache ] to dureeCour 
     store somDuree + dureeCour to somDuree 
     if indTache = 1 
          store dureeCour to dureeMax 
         else  
              if dureeCour > dureeMax 
                   store dureeCour to dureeMax 
              endif // # dureeCour > dureeMAx
     endif // # indTache=1
next // # indTache de1a nbTaches
store  max(somDuree   /   nbMachines ,  dureeMax) to dureeMin 



// # 2. Affectation des taches aux machines


// # 2.1 Initialisation du tableau de rpartititon

// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare nbTache [ nbTaches ]
// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare machineTacheNumero[ nbTaches , nbMachines ]
// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare machineTacheDuree[  nbTaches , nbMachines ]

for indTache := 1 to nbTaches 
     store 0 to nbTache[ indTache ] 
     for indMachine := 1 to nbMachines 
           store 0 to machineTacheNumero[ indTache , indMachine ] 
           store ( - 1) to machineTacheDuree[ indTache , indMachine ] 
     next // # indMachine de1a nbMachines
next // # indTache de1a nbTaches


// # 2.2 Boucle d'affectation

store 0 to tempsPris 
store 1 to machineCour 

for indTache := 1 to nbTaches 
    store dureeTache[ indTache ] to dureeCour 

    if tempsPris + dureeCour <= dureeMin 

         // # on peut affecter toute la tache a la machine courante

             store nbTache[ machineCour ] + 1 to tacheCour 
             store tacheCour to nbTache[ machineCour ] 
             store indTache to machineTacheNumero[ machineCour , tacheCour ] 
             store dureeCour to machineTacheDuree[ machineCour , tacheCour ] 
             store tempsPris + dureeCour to tempsPris 
             if tempsPris = dureeMin 
                  store machineCour + 1 to machineCour 
                      store 0 to tempsPris 
             endif // # tempsPris = dureeMin

        else  // # on n'a le droit d'affecter qu'une partie a la machine courante

             store nbTache[ machineCour ] + 1 to tacheCour 
             store tacheCour to nbTache[ machineCour ] 
             store indTache to machineTacheNumero[ machineCour , tacheCour ] 
             store dureeMin - tempsPris to resteTemps 
             store resteTemps to machineTacheDuree[ machineCour , tacheCour ] 

             // # et on affecte ce qui reste a la machine suivante

             store machineCour + 1 to machineCour 
             store nbTache[ machineCour ] + 1 to tacheCour 
             store tacheCour to nbTache[ machineCour ] 
             store indTache to machineTacheNumero[ machineCour , tacheCour ] 
             store dureeCour - resteTemps to machineTacheDuree[ machineCour , tacheCour ] 
             store dureeCour - resteTemps to tempsPris 

    endif // # tempsPris+dureeTache[ tacheCour ] <=  dureeMin

next // # indTache de1a nbTaches


// # 3. Affichage des donnes et des rpartitions

? " Il y avait ", str(nbMachines ,  2)," machines et ", str(nbTaches ,  2)," taches  rpartir." 
? " Voici la dure des taches : " 
? "   Tache    Dure (en heures)" 
for indTache := 1 to nbTaches 
     ?  str(indTache ,  8), str(dureeTache[ indTache ] ,  8) 
next // # indTache de1a nbTaches


? "" 
? " La dure minimale calcule est ", str(dureeMin ,  2)," heures." 
? "" 


for indMachine := 1 to nbMachines 
    ? "  -- machine ", str(indMachine ,  2)," : " 
    store nbTache[ indMachine ] to nbTacheCour 
    if nbTacheCour > 0 
         
             for indTache := 1 to nbTacheCour 
                  store machineTacheDuree[ indMachine , indTache ] to dureeCour 
                  store machineTacheNumero[ indMachine , indTache ] to tacheCour 
                  ?  replicate("  " ,  6)," tache ", str(tacheCour ,  2)," dure ", str(dureeCour ,  2) 
             next // # indTache de1 nbTacheCour
    endif // # numMachine > 0
next // # indTache de1a nbTaches

// ##-#   Fin de traduction pour macndb.prg via de galg -a macndb.alg -o dbase
