
Function mot( PHR : string ; X : integer) : string ; (* ## *)

const sep = ' ' ; (*seul separateur valide "LE BLANC *)

(* renvoie le Xeme mot de PHR ou vide *)

var nb : integer ; (* compteur des mots               *)
    ik : integer ; (* indice de caractere dans le mot *)
    L  : integer ; (* longueur de la chaine PHR       *)
    debut_mot, fin_mot :  integer ;
    (* indice de dbut et de fin du mot dans PHR  *)

begin (* de la function mot    *) (* # *)

 nb  := 0 ;
 PHR := PHR + sep + sep ;
 L   := length(PHR) ;
 ik  := 1 ;

 while (ik<=L-1) and (PHR[ik]=sep) do ik := ik+1 ;

 while (ik <= L-1) and (nb < (X-1) ) do begin
  if (PHR[ik]=sep) and (PHR[ik+1]<>sep)  then begin
         nb := nb + 1
  end ; (* finsi PHR[ik]=sep) *)
  ik := ik + 1
 end ; (* while ( ik <=  L ) and ... *)

(* le dbut est donc trouv ; cherchons la fin *)

 debut_mot := ik ;
 while (ik<=L ) do begin
  if PHR[ik] <> sep then  ik := ik + 1
    else  begin fin_mot  := ik ;
         ik  := L + 1
     end ; (* finsi *)
 end ; (* fintq ik<= L *)
 if fin_mot > debut_mot
  then mot := copy(PHR,debut_mot, fin_mot -debut_mot)
  else mot := ''

end ; (* function  mot         *) (* # *)


procedure   creebase(nom:string) ;

  var   nbcol    : integer ; (* nombre de colonnes *)
        nblig    : integer ; (* nombre de lignes   *)

procedure litStr ;

 var dbgstr   : byte    ; (* pour affichage de controle de la structure *)
     ligEnt   : string  ; (* ligne dans fichier d'entre *)
     loncolt  : string  ; (* chaine pour conversion numrique *)
     iconv    : integer ; (* variable pour retour conversion numrique *)

begin (* procedure litStr  *)

  dbgstr := 1 ; (* # avec affichage de controle *)
  dbgstr := 0 ; (* # sans affichage de controle *)

  {$I-}
  assign(fstr,nomstr) ; reset(fstr) ;
  if (ioresult<>0) then begin
     writeln(' le fichier ',nomstr,' n''est pas accessible.') ;
     writeln(' Abandon du programme') ;
     halt
  end ;

  {$I+}
  { write(' Parcours du fichier ',nomstr) ; }
  if (dbgstr=1) then begin writeln end ;
  nbcol := 0 ;
  while (not eof(fstr)) do begin
      nbcol := nbcol + 1 ;
      readln(fstr,ligent) ;
      nomCol[nbcol] := mot(ligent,1) ;
      nomCol[nbcol] := copy(nomCol[nbcol]+'               ',1,15) ;
      typCol[nbcol] := mot(ligent,2) ;
      typCol[nbcol] := copy(typCol[nbcol]+'?',1,1) ;
      lonColt       := mot(ligent,3) ;
      val(loncolt,lonCol[nbcol],iconv) ;
      if (iconv<>0) then begin lonCol[nbcol] := 8 end ;
      lonColt       := mot(ligent,4) ;
      val(loncolt,decCol[nbcol],iconv) ;
      if (iconv<>0) then begin decCol[nbcol] := 2 end ;
      if (dbgstr=1) then begin
          write(nbcol:3,' : ',nomCol[nbcol]) ;
          write(' typ ',typCol[nbcol]) ;
          write(' lon ',lonCol[nbcol]:2) ;
          write(' dec ',decCol[nbcol]:2) ;
          writeln ;
      end ;
  end ;
  close(fstr) ;
  { writeln(' : ',nbcol:2,' colonne(s) vues) ') ; }


end ; (* procedure litStr  *)

procedure litDat ;

 var dbgsdf   : byte    ; (* pour affichage de controle des donnes     *)
     ligEnt   : string  ; (* ligne dans fichier d'entre *)

begin (* procedure litDat  *)

  dbgsdf := 1 ; (* # avec affichage de controle *)
  dbgsdf := 0 ; (* # sans affichage de controle *)

  {$I-}
  assign(fsdf,nomsdf) ; reset(fsdf) ;
  if (ioresult<>0) then begin
     writeln(' le fichier ',nomsdf,' n''est pas accessible.') ;
     writeln(' Abandon du programme') ;
     halt
  end ;

  {$I+}
  { write(' Parcours du fichier ',nomsdf) ; }
  nblig := 0 ;
  while (not eof(fsdf)) do begin
      nblig := nblig + 1 ;
      readln(fsdf,ligent) ;
      { writeln(nbcol:3,' : ',ligent) ; }
  end ;
  close(fsdf) ;
  { writeln(' : ',nblig:2,' ligne(s) vues) ') ; }

end ; (* procedure litDat  *)

procedure decomp16(nombre,nbz:integer) ;
   {# decomposition en base 16 et criture sur nbz/2 octets }

   var ie : byte ;
       k  : byte ;
       mm : byte ;
       nn : byte ;
       bz : array[1..32] of byte ;
       j  : byte ;

begin (* procedure decomp16  *)

   ie := 0 ;
   for k:=1 to nbz do begin  bz[k] := 0 end ;
   while (nombre>0) do begin
      ie     := ie + 1 ;
      mm     := nombre div 16 ;
      nn     := nombre - 16*mm ;
      bz[ie] := nn ;
      nombre := mm ;
   end ;
   for j:=1 to (nbz div 2) do begin
       write(fdbf,chr(16*bz[2*j]+bz[2*j-1]))
   end ; (* # fin pour j *)

end ; (* procedure decomp16  *)

procedure mkStr ;

 var c : byte ; (* numro du cractres  crire  ; *)
     ye,mo,da,dw : word ; (* pour la date *)
     lent : integer ;
     lenr : integer ;
     ze   : byte ;
     nomf : string ;
     i    : integer ;
     ic   : integer ;
     loncCar : integer ;
     loncNum : integer ;
     lec : char ;

begin (* procedure mkStr  *)

  lonCcar := 0 ; lonCnum := 0 ;

  (* dtermination des longueurs *)

  for ic := 1 to nbcol do begin
    if (typCol[ic]='C') then lonCcar := lonCcar + lonCol[ic] ;
    if (typCol[ic]='N') then lonCnum := lonCnum + lonCol[ic] ;
  end ;

  (* # octet  0 : 83 si champ mmo, 3 sinon *)

  c := 3 ;
  write(fdbf,chr(c) ) ;

  (* # octets 1  3 : date en AA MM DD *)
  (* # exemple : 10 janvier 99 donne 63 01 0A *)

  getdate(ye,mo,da) ;
  if (ye>=2000) then ye := ye - 2000 ;
  if (ye>=1900) then ye := ye - 1900 ;
  write(fdbf,chr(ye) ) ;
  write(fdbf,chr(mo) ) ;
  write(fdbf,chr(da) ) ;

  (* # octets 4  7 : nombre d'enregistrements *)
  (* # si count vaut   a b c d e f g h en base 16 *)
  (* # on crit  gh ef cd ab *)
  (* # exemple : 98010 donne 0 0 0 1 7 E D A *)
  (* # qu'on code en DA 7E 01 00 *)

  decomp16(nblig,8) ;

  (* # octets 8-9 : longueur totale de l'en-tte *)
  (* # si lent  vaut   a b c d  en base 16 *)
  (* # on crit  cd ab *)
  (* # exemple : 32  donne 0 2 0 0 *)
  (* # qu'on code en 20 00 *)
  (* # longueur : 32 + flogdcount*32 + 1 *)

  lent := 32*(1+nbcol) + 1 ; decomp16(lent,4) ;

  (* # octets 10-11 : longueur de chaque enregistrement *)

  lenr := 1 + lonCcar + lonCnum ; decomp16(lenr,4) ;

  (* # octets 12-31 : rservs *)

  for i:=1 to 20 do begin
      ze := 0 ; write(fdbf,chr(ze)) ;
  end ; (* # fin pour i *)

  for ic:=1 to nbcol do begin
    (* # pour chaque champ 32 octets : *)
    (* # 00-10 nom de la zone (complter sur 10 car avec des zros en hexa)  *)
    (* #    11 type  C N  L D M  *)
    (* # 12-15 place pour l'adresse  *)
    (* #    16 taille de la zone  *)
    (* #    17 nb de dcimales pour type N *)
    (* # 18-31 rservs *)

    nomf := copy(nomCol[ic]+'             ',1,11) ;
    for i:=1 to 11 do begin
      if (copy(nomf,i,1)=' ')
         then write(fdbf,chr(0))
         else begin
                lec := nomf[i] ;
                write(fdbf,upcase(lec)) ;
              end
    end ;(* # fin pour i *)

    write(fdbf,typCol[ic]) ;

    for i:=1 to 4 do begin
        ze := 0 ; write(fdbf,chr(ze)) ;
    end ; (* # fin pour i *)

    write(fdbf,chr(lonCol[ic])) ;
    if (typCol[ic]='C')
       then write(fdbf,chr(ze)) else
    if (typCol[ic]='N') then write(fdbf,chr(decCol[ic])) ;

    for i:=18 to 31 do begin
        ze := 0 ; write(fdbf,chr(ze)) ;
    end ; (* # fin pour i *)

  end ;(* # fin pour ic *)

  (* # octet de valeur 13 comme indicateur de fin des descripteurs *)

  write(fdbf,chr(13)) ;

end ; (* procedure mkStr  *)

procedure mkDat ;

  var idl,pluspar,poinpar : integer ;
      deb,fin : integer ;
      ligent : string ;
      motc : string ;
      valr : real ;
      iconv : integer ;
      i,j : integer ;

begin (* procedure mkDat  *)

  (* # on met les donnes (octet 0, valeur 32 enreg. non "deleted" ) *)

  idl := 0 ; pluspar :=  100 ; poinpar := 25  ;
  {$I-}
  assign(fsdf,nomsdf) ; reset(fsdf) ;
  if (ioresult<>0) then begin
     writeln(' le fichier ',nomsdf,' n''est pas accessible.') ;
     writeln(' Abandon du programme') ;
     halt
  end ;

  {$I+}
  while (not eof(fsdf)) do begin
    readln(fsdf,ligent) ;
    idl := idl + 1 ;
    write(fdbf,chr(32)) ;
    deb := 1 ;
    for i:=1 to nbcol do begin
        fin := deb + lonCol[i] ;
        motc := copy(ligent,deb,lonCol[i]) ;
        if (typCol[i]='C') then begin
           while (length(motc)<lonCol[i]) do begin motc := motc+' ' end ;
        end ; (* # fin si C *)
        if (typCol[i]='N') then begin
           val(motc,valr,iconv) ;
           str(valr:lonCol[i]:decCol[i],motc) ;
        end ; (* # fin si N *)
        for j:=1 to length(motc) do begin
            write(fdbf,copy(motc,j,1)) ;
        end ; (* # fin pour j *)
        deb := fin ;
    end ; (* # fin pour i *)
  end ; (* # fin tant que *)
  close(fsdf) ;

  (* # fermeture du fichier avec le code 26 *)

  write(fdbf,chr(26)) ;

end ; (* procedure mkDat  *)

(*******************************************************************)

begin (* procedure   creebase  *)

  assign(fdbf,nomdbf) ; rewrite(fdbf) ;

  litStr ;
  litDat ;
  mkStr  ;
  mkDat  ;

  close(fdbf) ;

end ; (* procedure   creebase  *)
