(* ##-#   Fichier maxoccmonopascal.pas issu de galg -a maxoccmonopascal.alg -o pascal *)
(* ##-#  ============================================================================ *)
(* ##-#      03/08/2001 23:17.16 *)

(* ############################################### *)
(* #                                              # *)
(* #                                              # *)
(* #   dtermination du maximum dans un tableau   # *)
(* #   et comptage du nombre d'occurences de ce   # *)
(* #   maximum  en une seule boucle               # *)
(* #                                              # *)
(* #                                              # *)
(* ################################################ *)
(* #                                              # *)
(* # auteur : gh                                  # *)
(* #                                              # *)
(* ################################################ *)

PROGRAM maxoccmonopascal ; 


(* ##-#  Ajout de format.pas via le code #>  *)

function format( nombre : integer ; longueur : integer ) : string ;
  var chaine : string ;
begin
  str(nombre:longueur,chaine) ;
  format := chaine ;
end ;

(* ##-#  Fin d'ajout de format.pas via le code #>  *)
(* ##-#  Ajout de entierAuHasard.pas via le code #>  *)

function entierAuHasard( vmin, vmax : integer ) : integer ;
begin
  entierAuHasard := trunc( vmin + random( vmax-vmin+1 ) ) ;
end ;

(* ##-#  Fin d'ajout de entierAuHasard.pas via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
var
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbElt      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
indb       : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
monT       : array[1..100] of integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
valMax     : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbMax      : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
eltCourant : integer ;

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN


(* # initialisation du tableau avec 15 lments *)
(* # entiers entre 10 et 20 *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
Randomize ;

nbElt := 15 ;
for indb := 1 to nbElt do begin 
     monT[ indb ] :=  entierAuHasard(10 ,  20)  ;
end ; (* # indb de1a nbElt-1 *)


(* # initialisation de la valeur du maximum (valMax) *)
(* # et de son nombre d'occurences (nbMax) *)

valMax := monT[ nbElt ] ;
nbMax := 1 ;


(* # on parcourt alors le tableau *)
(* # sans utiliser le dernier lment dja comptabilis *)

for indb := 1 to nbElt-1 do begin 
     eltCourant := monT[ indb ] ;
     if eltCourant  >  valMax 
        then begin  (* # nouveau maximum local *)
              valMax := eltCourant ;
              nbMax := 1 ;
        end else begin 
              if eltCourant  =  valMax 
                 then begin  (* # une fois de plus le maximum *)
                       nbMax := nbMax  +  1 ;
              end ; (* # nouvelle occurence du maximum *)
     end ; (* # nouveau maximum *)
end ; (* # indb de1a 10 *)


(* # affichage de fin *)

writeln( ' Le maximum dans le tableau est : ',valMax ) ; 
writeln( ' et il apparait ',nbMax,' fois.' ) ; 
writeln( ' Pour vrification, voici les lments du tableau : ' ) ; 

for indb := 1 to nbElt do begin 
    writeln( '    lment  ', format(indb ,  3) ,' : ', format(monT[ indb ] ,  4)  ) ; 
end ; (* # indb de1a nbElt-1 *)

END.

(* ##-#   Fin de traduction pour maxoccmonopascal.pas via de galg -a maxoccmonopascal.alg -o pascal *)
