/* ##-#   Fichier maxocc.rex issu de galg -a maxocc.alg -o rex */
/* ##-#  ===================================================== */
/* ##-#      10/07/2001 13:28.52 */
/* ##-#  (fichier post-modifi via la table de correspondance maxocc.tdc) */
/* # auteur : gh */

/* ##-#  Ajout de maxocc_dr.rex via le code #<  */
nomTab = "monT."

/* ##-#  Fin d'ajout de maxocc_dr.rex via le code #<  */

/* # initialisation du tableau avec 15 lments */
/* # entiers entre 10 et 100 */


nbElt = 15 
  init_Tab("monT" nbElt 10 100) 

/* # dtermination du max et comptage du nb d'occurences */
/* # du max en une seule boucle */

/* # initialisation de la valeur du maximum (valMax) */
/* # et de son nombre d'occurences (nbMax) */

valMax = monT.nbElt; 
nbMax = 1 

/* # on parcourt alors le tableau */
/* # sans utiliser le dernier lment dja comptabilis */

do indb=1 to nbElt-1 
     eltCourant = monT.indb; 
     if eltCourant>valMax 
        then ; do ;  /* # nouveau maximum local */
              valMax = eltCourant 
              nbMax = 1 
        end ; else ; do ; 
              if eltCourant=valMax 
                 then ; do ;  /* # une fois de plus le maximum */
                       nbMax = nbMax+1 
              end /* # nouvelle occurence du maximum */
     end /* # nouveau maximum */
end /* # indb de1a 10 */

/* # affichage de fin */

say " Le maximum dans le tableau est : " valMax 
say " et il apparait " nbMax " fois." 
say " Pour vrification, voici les lments du tableau : " 

  affiche_Tab("monT" 1 nbElt 4) 
  exit 

/* ##-#  Ajout de maxocc_fr.rex via le code #<  */

/* sous-programmes */

init_Tab: procedure expose (nomTab)

  parse arg sonNom  nbe  vmin vmax
  say "   ===>  Vous demandez " nbe " lments entre " vmin " et " vmax  " pour le tableau : " sonNom
  do i = 1 to nbe
     elt = random(vmin,vmax)
     lins =  nomTab||i||" = " elt
     interpret lins
  end /* fin pour i */

return ""

affiche_Tab: procedure expose (nomTab)

  parse arg sonNom  indMin  indMax largeurF
  say "   ===>  Affichage des lments " indMin "  " indMax " en largeur " largeurF " du tableau " sonNom
  do i = indMin to indmax
     elt = value(nomTab||i)
     say "    Elment " format(i,3) " : " format(elt,largeurF)
  end /* fin pour i */

return ""
/* ##-#  Fin d'ajout de maxocc_fr.rex via le code #<  */
