/* ##-#   Fichier maxoccRex.rex issu de galg -a maxoccRex.alg -o rexx */
/* ##-#  ============================================================ */
/* ##-#      29/07/2001 12:37.38 */

/* ################################################ */
/* #                                              # */
/* #                                              # */
/* #   dtermination du maximum dans un tableau   # */
/* #   et comptage du nombre d'occurences de ce   # */
/* #   maximum  en une seule boucle               # */
/* #                                              # */
/* #                                              # */
/* ################################################ */
/* #                                              # */
/* # auteur : gh                                  # */
/* #                                              # */
/* ################################################ */


/* ##-#  Ajout de maxoccDebut.rex via le code #>  */

nomTab = "monT."


/* ##-#  Fin d'ajout de maxoccDebut.rex via le code #>  */

/* # initialisation du tableau avec 15 lments */
/* # entiers tirs au hasard entre 10 et 100 */

nbElt = 15 
 init_Tab("monT" ,  nbElt ,  10 ,  20) 


/* # initialisation de la valeur du maximum (valMax) */
/* # et de son nombre d'occurences (nbMax) */

valMax = monT.nbElt  
nbMax = 1 


/* # on parcourt alors le tableau */
/* # sans utiliser le dernier lment dja comptabilis */

do indb=1 to nbElt-1 
     eltCourant = monT.indb  
     if eltCourant > valMax 
        then ; do ;  /* # nouveau maximum local */
              valMax = eltCourant 
              nbMax = 1 
        end ; else ; do ; 
              if eltCourant = valMax 
                 then ; do ;  /* # une fois de plus le maximum */
                       nbMax = nbMax + 1 
              end /* # nouvelle occurence du maximum */
     end /* # nouveau maximum */
end /* # indb de1a 10 */


/* # affichage de fin */

say " Le maximum dans le tableau est : " valMax 
say " et il apparait " nbMax " fois." 
say " Pour vrification, voici les lments du tableau : " 

 affiche_Tab("monT" ,  1 ,  nbElt ,  4) 

exit 

/* ##-#  Ajout de maxoccFin.rex via le code #>  */


/* sous-programmes */

init_Tab: procedure expose (nomTab)

  parse arg sonNom  , nbe  , vmin , vmax
  do i = 1 to nbe
     elt = random(vmin,vmax)
     lins =  nomTab||i||" = " elt
     interpret lins
  end /* fin pour i */

return ""

affiche_Tab: procedure expose (nomTab)

  parse arg sonNom  , indMin  , indMax , largeurF
  do i = indMin to indmax
     elt = value(nomTab||i)
     say "    Elment " format(i,3) " : " format(elt,largeurF)
  end /* fin pour i */

return ""

/* ##-#  Fin d'ajout de maxoccFin.rex via le code #>  */

/* ##-#   Fin de traduction pour maxoccRex.rex via de galg -a maxoccRex.alg -o rexx */
