/* ##-#   Fichier maxoccmonoRex.rex issu de galg -a maxoccmonoRex.alg -o rexx */
/* ##-#  ==================================================================== */
/* ##-#      29/07/2001 12:2.30 */

/* ############################################### */
/* #                                              # */
/* #                                              # */
/* #   dtermination du maximum dans un tableau   # */
/* #   et comptage du nombre d'occurences de ce   # */
/* #   maximum  en une seule boucle               # */
/* #                                              # */
/* #                                              # */
/* ################################################ */
/* #                                              # */
/* # auteur : gh                                  # */
/* #                                              # */
/* ################################################ */


/* # initialisation du tableau avec 15 lments */
/* # entiers entre 10 et 20 */

nbElt = 15 
do indb=1 to nbElt 
     monT.indb  =  random(10 ,  20) 
end /* # indb de1a nbElt-1 */


/* # initialisation de la valeur du maximum (valMax) */
/* # et de son nombre d'occurences (nbMax) */

valMax = monT.nbElt  
nbMax = 1 


/* # on parcourt alors le tableau */
/* # sans utiliser le dernier lment dja comptabilis */

do indb=1 to nbElt-1 
     eltCourant = monT.indb  
     if eltCourant > valMax 
        then ; do ;  /* # nouveau maximum local */
              valMax = eltCourant 
              nbMax = 1 
        end ; else ; do ; 
              if eltCourant = valMax 
                 then ; do ;  /* # une fois de plus le maximum */
                       nbMax = nbMax + 1 
              end /* # nouvelle occurence du maximum */
     end /* # nouveau maximum */
end /* # indb de1a 10 */


/* # affichage de fin */

say " Le maximum dans le tableau est : " valMax 
say " et il apparait " nbMax " fois." 
say " Pour vrification, voici les lments du tableau : " 

do indb=1 to nbElt 
    say "    lment  "  format(indb ,  3) " : "  format(monT.indb  ,  4) 
end /* # indb de1a nbElt-1 */

/* ##-#   Fin de traduction pour maxoccmonoRex.rex via de galg -a maxoccmonoRex.alg -o rexx */
