proc  _format  { nombre longueur } {
  set chformat [append "%" $longueur "d"]
  return [format %$chformat $nombre]
} ; # fin proc _format

############################################################

proc  codeAscii  { caract } {
  return [scan $caract "%c"]
} ; # fin proc codeAscii

############################################################

proc  concatene  { debut fin } {
  return "$debut$fin" ;
} ; # fin proc concatene

############################################################

proc  copies  { chaine nb } {
  set repete ""
  for  { set ind 1  }  { $ind <= $nb }   { set ind [ incr ind] }  {
    set repete "$repete$chaine"
  } ; # fin de pour ind
  return $repete
} ; # fin proc copies

############################################################

proc date { }  {
 set  ladate [ clock format [clock seconds] -format " %d/%m/%y " ]
 return $ladate
} ; # fin de date

############################################################

proc  entier  { chaine } {
  set res  [regexp "^\[0-9\]+$" $chaine]
  return [expr $res==1]
} ; # fin proc entier

############################################################

proc  entierAuHasard  { vmin vmax } {
  return [ expr int($vmin + ($vmax-$vmin)*rand()) ]
} ; # fin proc entierAuHasard

############################################################

proc heure { }  {
 set  lheure [ clock format [clock seconds] -format " %H:%M" ]
 return $lheure
} ; # fin de heure

############################################################

proc maju { chaine }  {
 regsub -all "" $chaine "A" chaine
 regsub -all "" $chaine "A" chaine
 regsub -all "" $chaine "C" chaine
 regsub -all "" $chaine "E" chaine
 regsub -all "" $chaine "E" chaine
 regsub -all "" $chaine "E" chaine
 regsub -all "" $chaine "I" chaine
 regsub -all "" $chaine "O" chaine
 regsub -all "" $chaine "U" chaine
 regsub -all "" $chaine "U" chaine
 return [string toupper $chaine]
} ; # fin de maju

############################################################

proc  nbParametres  { listeParam } {
 return [llength $listeParam]
} ; # fin proc nbParametres

############################################################

proc  parametre  { listeParam position } {
 return [lindex $listeParam [expr $position - 1 ] ]
} ; # fin proc parametre

############################################################

proc  partieEntiere  { nombre } {
  return [expr int( $nombre ) ]
} ; # fin proc partieEntiere

############################################################

proc  sousChaine  { chaine debut longueur } {
  return [string range $chaine [expr $debut-1] [expr $debut+$longueur-2] ]
} ; # fin proc sousChaine

############################################################

proc  valeur  { chaine } {
 return [expr " 0 + $chaine "]
} ; # fin proc parametre
