##-#   Fichier tabmultTcl.tcl issu de galg -a tabmultTcl.alg -o tcl
##-#  =============================================================
##-#      01/08/2001 20:14.35

#####################################################
#                                                   #
# tabmult.alg -- un exemple simple d'algorithme :   #
#                la table de multiplication         #
#                                                   #
#  auteur : gh                                      #
#                                                   #
#####################################################
#                                                   #
#  on demande  l'utilisateur un nombre entier et   #
#  on le relance tant que le nombre n'est pas       #
#  entier.                                          #
#                                                   #
#  lorsque le nombre est entier, on afiche sa       #
#  table avec cadrage des units sous les units,   #
#  des dizaines sous les dizaines etc.              #
#                                                   #
#####################################################

##-#  Ajout de entier.tcl via le code #> 

proc  entier  { chaine } {
  set res  [regexp "^\[0-9\]+$" $chaine]
  puts "pour $chaine je renvoie [expr $res==1] "
  return [expr $res==1]
} ; # fin proc entier

##-#  Fin d'ajout de entier.tcl via le code #> 
##-#  Ajout de _format.tcl via le code #> 

proc  _format  { nombre longueur } {
  set chformat [append "%" $longueur "d"]
  return [format %$chformat $nombre]
} ; # fin proc _format


##-#  Fin d'ajout de _format.tcl via le code #> 

# demande initiale

puts " Donner un entier  "
set nbChoisi [gets stdin] 


# relance ventuelle

while { (! [entier $nbChoisi ]) }  { 
    puts " nombre incorrect. Redonner un nombre ENTIER  "
    set nbChoisi [gets stdin] 
} ; # nombre invalide


# boucle d'affichage

puts " Table de   $nbChoisi  "
for  { set indb 1  }    { $indb  <= 10  }   { set indb [ incr indb ] }  { 
    set produit [expr "$nbChoisi * $indb " ]
 

    set find [_format $indb 2 ]  

    set fpro [_format $produit 5 ]  

    puts "$find  fois  $nbChoisi  =  $fpro  "
} ; # indb de1a 10

##-#   Fin de traduction pour tabmultTcl.tcl via de galg -a tabmultTcl.alg -o tcl
