##-#   Fichier triFusTcl.tcl issu de galg -a triFusTcl.alg -o tcl
##-#  ===========================================================
##-#      03/10/2001 18:8.06

# triFus.alg : trifusion de 2 fichiers dj tris
#              auteur -- gH

source mot.tcl
proc  mot  { phrase numero} {
  return [lindex $phrase [expr $numero-1] ]
} ; # fin proc mot

# nommage des variables pour noms de fichier

set nomFic1 "triFus.f1"
set nomFic2 "triFus.f2"
set nomFic3 "triFus.f3"

# initialisation des nombres de lignes lues et crites

set nbl1 0
set nbl2 0
set nbl3 0

# ouverture des 3 fichiers

 set fic1 [open $nomFic1  r ]
 set fic2 [open $nomFic2  r ]
 set fic3 [open $nomFic3  w ]

# lecture du premier enregistrement sur fic1

if { !  [eof  $fic1 ] == 1 } {
   # lecture possible 1
         set ligne1 [gets $fic1 ]
         set nbl1   [expr "$nbl1 + 1 " ]

} ; # lecture du fic1

# lecture du premier enregistrement sur fic2

if { !  [eof  $fic2 ]  == 1 } {
   # lecture possible 2
         set ligne2 [gets $fic2 ]
         set nbl2 [expr "$nbl2 + 1 " ]

} ; # lecture du fic1

# boucle de tri-fusion

while { (!  [eof  $fic1 ] == 1 ) && (!  [eof  $fic2 ] == 1 ) }  {
puts " mot1 : [mot $ligne1 2 ] "
puts " mot2 : [mot $ligne2 2 ] "
  if { [string compare [mot $ligne1 2 ] [mot $ligne2 2 ]] < 1  } {
     # criture de fic1 vers fic3
            puts $fic3 "(fic1)    $ligne1"
            set nbl3 [expr "$nbl3 + 1 " ]

            if { (!  [eof  $fic1] == 1)  } {
               # lecture possible 3
                     set ligne1 [gets $fic1 ]
                     set nbl1 [expr "$nbl1 + 1 " ]

               } else { set ligne1 ""
            } ; # lecture du fic1
     } else { # criture de fic2 vers fic3
            puts $fic3 "(fic2)   $ligne2"
            set nbl3 [expr "$nbl3 + 1 " ]

            if { (!  [eof  $fic2] == 1)  } {
               # lecture possible 4
                     set ligne2 [gets $fic2 ]
                     set nbl2 [expr "$nbl2 + 1 " ]

               } else { set ligne2 ""
            } ; # lecture du fic2
  } ; # comparaison ligne 1 et ligne 2
} ; # lecture sur les deux fichiers

if { ( [string length  $ligne1 ] > 0) && ( [string length  $ligne2 ] > 0)  } {

           if { [mot $ligne1 2 ] <= [mot $ligne2 2 ]  } {
              # criture de fic1 vers fic3
                     puts $fic3 "(fic1) $ligne1"
                     set nbl3 [expr "$nbl3 + 1 " ]

                     puts $fic3 "(fic2) $ligne2"
                     set nbl3 [expr "$nbl3 + 1 " ]

              } else { # criture de fic2 vers fic3
                     puts $fic3 "(fic2) $ligne2"
                     set nbl3 [expr "$nbl3 + 1 " ]

                     puts $fic3 "(fic1) $ligne1"
                     set nbl3 [expr "$nbl3 + 1 " ]

           } ; # comparaison ligne 1 et ligne 2
} ; # on compare en fin de fichier

# s'il reste des lignes dans f1, on recopie f1

while { !  [eof  $fic1] == 1 }  {
     set ligne1 [gets $fic1 ]
     set nbl1 [expr "$nbl1 + 1 " ]

     puts $fic3 "\[fic1\] $ligne1"
     set nbl3 [expr "$nbl3 + 1 " ]

} ; # lecture sur f1

# s'il reste des lignes dans f2, on recopie f2

while { !  [eof  $fic2] == 1 }  {
     set ligne2 [gets $fic2 ]
     set nbl2 [expr "$nbl2 + 1 " ]

     puts $fic3 "\[fic2\] $ligne2"
     set nbl3 [expr "$nbl3 + 1 " ]

} ; # lecture sur f1

# fermeture des fichiers

 close $fic1
 close $fic2
 close $fic3

# affichage du nombre de lignes lues et crites :

puts "      [format $nbl1 4 ]  lignes lues sur  $nomFic1  "
puts "      [format $nbl2 4 ]  lignes lues sur  $nomFic2  "
puts "      [format $nbl3 4 ]  lignes crites sur  $nomFic3  "

exit 0

##-#   Fin de traduction pour triFusTcl.tcl via de galg -a triFusTcl.alg -o tcl
