##-#   Fichier triFusC.tcl issu de galg -a triFusC.alg -o tcl
##-#  =======================================================
##-#      04/10/2001 14:53.12

# triFus.alg : trifusion de 2 fichiers dj tris
#              auteur -- gH

##-#  Ajout de triFusC.inc via le code #> 

# -- triFusC.inc

chaine nomFic1,
       nomFic2,
       nomFic3,
       ligne1,
       ligne2     ;

int nbl1,
    nbl2,
    nbl3  ;

FILE *fic1,
     *fic2,
     *fic3   ;

###################################################

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

###################################################

int fin_de_fichier(FILE nomf) {
  return eof(nomf) ;
} /* fin de fin_de_fichier (hum !) */

###################################################

char* sousChaine(chaine ancienne, int debut, int longueur) {
chaine nouvelle ;
int ic ;
  strcpy(nouvelle,ancienne) ;
  if (debut<0) { debut = 0 ; } ;
  if (longueur>strlen(ancienne)) { longueur = strlen(ancienne) ; } ;
  nouvelle[longueur] = 0 ;
  for (ic=0;ic<strlen(nouvelle);ic++) {
    nouvelle[ic] = ancienne[debut+ic-1] ;
  } ;
  return(nouvelle) ;
} /* fin de sousChaine */

###################################################

char* mot(chaine ancienne, int numero) {
  return(ancienne) ;
} ;


##-#  Fin d'ajout de triFusC.inc via le code #> 

##-#  La ligne suivante provient d'un ajout via le code #: 
int main() {

# nommage des variables pour noms de fichier

set nomFic1 "triFus.f1" 
set nomFic2 "triFus.f2" 
set nomFic3 "triFus.f3" 

# initialisation des nombres de lignes lues et crites

set nbl1 0 
set nbl2 0 
set nbl3 0 

# ouverture des 3 fichiers

 set fic1 [open $nomFic1  r ] 
 set fic2 [open $nomFic2  r ] 
 set fic3 [open $nomFic3  w ] 

# lecture du premier enregistrement sur fic1

if { ! [fin_de_fichier $fic1 ]  } { 
   # lecture possible
         gets $fic1  ligne1 
         set nbl1 [expr "$nbl1 + 1 " ]
 
} ; # lecture du fic1

# lecture du premier enregistrement sur fic2

if { ! [fin_de_fichier $fic2 ]  } { 
   # lecture possible
         gets $fic2  ligne2 
         set nbl2 [expr "$nbl2 + 1 " ]
 
} ; # lecture du fic1

# boucle de tri-fusion

while { (! [fin_de_fichier $fic1 ]) && (! [fin_de_fichier $fic2 ]) }  { 
  if { [_mot $ligne1 2 ] <= [_mot $ligne2 2 ]  } { 
     # criture de fic1 vers fic3
            puts  $fic3  " (fic1)   $ligne1  "
            set nbl3 [expr "$nbl3 + 1 " ]
 
            if { (! [fin_de_fichier $fic1 ])  } { 
               # lecture possible
                     gets $fic1  ligne1 
                     set nbl1 [expr "$nbl1 + 1 " ]
 
               } else { set ligne1 "" 
            } ; # lecture du fic1
     } else { # criture de fic2 vers fic3
            puts  $fic3  " (fic2)   $ligne2  "
            set nbl3 [expr "$nbl3 + 1 " ]
 
            if { (! [fin_de_fichier $fic2 ])  } { 
               # lecture possible
                     gets $fic2  ligne2 
                     set nbl2 [expr "$nbl2 + 1 " ]
 
               } else { set ligne2 "" 
            } ; # lecture du fic2
  } ; # comparaison ligne 1 et ligne 2
} ; # lecture sur les deux fichiers

if { ( [string length  $ligne1 ] > 0) && ( [string length  $ligne2 ] > 0)  } { 
     
           if { [_mot $ligne1 2 ] <= [_mot $ligne2 2 ]  } { 
              # criture de fic1 vers fic3
                     puts  $fic3  " (fic1)   $ligne1  "
                     set nbl3 [expr "$nbl3 + 1 " ]
 
                     puts  $fic3  " (fic2)   $ligne2  "
                     set nbl3 [expr "$nbl3 + 1 " ]
 
              } else { # criture de fic2 vers fic3
                     puts  $fic3  " (fic2)   $ligne2  "
                     set nbl3 [expr "$nbl3 + 1 " ]
 
                     puts  $fic3  " (fic1)   $ligne1  "
                     set nbl3 [expr "$nbl3 + 1 " ]
 
           } ; # comparaison ligne 1 et ligne 2
} ; # on compare en fin de fichier

# s'il reste des lignes dans f1, on recopie f1

while { ! [fin_de_fichier $fic1 ] }  { 
     gets $fic1  ligne1 
     set nbl1 [expr "$nbl1 + 1 " ]
 
     puts  $fic3  " [fic1]   $ligne1  "
     set nbl3 [expr "$nbl3 + 1 " ]
 
} ; # lecture sur f1

# s'il reste des lignes dans f2, on recopie f2

while { ! [fin_de_fichier $fic2 ] }  { 
     gets $fic2  ligne2 
     set nbl2 [expr "$nbl2 + 1 " ]
 
     puts  $fic3  " [fic2]   $ligne2  "
     set nbl3 [expr "$nbl3 + 1 " ]
 
} ; # lecture sur f1

# fermeture des fichiers

 close $fic1  
 close $fic2  
 close $fic3  

# affichage du nombre de lignes lues et crites :

puts "      [formatEntier $nbl1 4 ]  lignes lues sur  $nomFic1  "
puts "      [formatEntier $nbl2 4 ]  lignes lues sur  $nomFic2  "
puts "      [formatEntier $nbl3 4 ]  lignes crites sur  $nomFic3  "

exit 0  

##-#   Fin de traduction pour triFusC.tcl via de galg -a triFusC.alg -o tcl
