##-#   Fichier triFusPerl.pl issu de galg -a triFusPerl.alg -o perl
##-#  =============================================================
##-#      12/10/2001 13:29.48

# triFus.alg : trifusion de 2 fichiers dj tris
#              auteur -- gH

##-#  La ligne suivante provient d'un ajout via le code #: 
use FileHandle ; # obligatoire pour la gestion de fichiers ;

# nommage des variables pour noms de fichier

$nomFic1 = "triFus.f1"  ;
$nomFic2 = "triFus.f2"  ;
$nomFic3 = "triFus.f3"  ;

# initialisation des nombres de lignes lues et crites

$nbl1 = 0  ;
$nbl2 = 0  ;
$nbl3 = 0  ;

# ouverture des 3 fichiers

$fic1  = new FileHandle ; 
$fic1 ->open("<$nomFic1 ") or die(" impossible de lire dans $nomFic1 ") ; 
$fic2  = new FileHandle ; 
$fic2 ->open("<$nomFic2 ") or die(" impossible de lire dans $nomFic2 ") ; 
$fic3  = new FileHandle ; 
$fic3 ->open(">$nomFic3 ") or die(" impossible d'crire dans $nomFic3 ") ; 

# lecture du premier enregistrement sur fic1

if (not $fic1 -> eof() ) { 
   # lecture possible
         $ligne1  = $fic1 ->getline() ; 
chomp($ligne1 ) ; 
         $nbl1 = $nbl1 + 1  ;
} ; # lecture du fic1

# lecture du premier enregistrement sur fic2

if (not $fic2 -> eof() ) { 
   # lecture possible
         $ligne2  = $fic2 ->getline() ; 
chomp($ligne2 ) ; 
         $nbl2 = $nbl2 + 1  ;
} ; # lecture du fic1

# boucle de tri-fusion

while (( not $fic1 -> eof() ) and ( not $fic2 -> eof() ) ) { 
  if (&chaineAvant( &mot( $ligne1 , 2 ) , &mot( $ligne2 , 2 ) ) == 1 ) { 
     # criture de fic1 vers fic3
            print $fic3  " (fic1) " ." ". $ligne1."\n" ; 
            $nbl3 = $nbl3 + 1  ;
            if (( not $fic1 -> eof() ) ) { 
               # lecture possible
                     $ligne1  = $fic1 ->getline() ; 
chomp($ligne1 ) ; 
                     $nbl1 = $nbl1 + 1  ;
               }
 else { $ligne1 = ""  ;
            } ; # lecture du fic1
     }
 else { # criture de fic2 vers fic3
            print $fic3  " (fic2) " ." ". $ligne2."\n" ; 
            $nbl3 = $nbl3 + 1  ;
            if (( not $fic2 -> eof() ) ) { 
               # lecture possible
                     $ligne2  = $fic2 ->getline() ; 
chomp($ligne2 ) ; 
                     $nbl2 = $nbl2 + 1  ;
               }
 else { $ligne2 = ""  ;
            } ; # lecture du fic2
  } ; # comparaison ligne 1 et ligne 2
} ; # lecture sur les deux fichiers

print " fin de TQ, il reste : " ." ". $ligne1 ." ". " et " ." ". $ligne2."\n" ; 

# un des deux lignes n'a pas t recopie, donc :

if (&chaineAvant( &mot( $ligne1 , 2 ) , &mot( $ligne2 , 2 ) ) == 1 ) { 
     # criture de fic1 vers fic3
       if (length( $ligne1 ) > 0 ) { 
          # criture de fic1 vers fic3
                 $nbl3 = $nbl3 + 1  ;
                 print $fic3  " [fic1] " ." ". $ligne1."\n" ; 
       } ; # on compare en fin de fichier
       if (length( $ligne2 ) > 0 ) { 
          # criture de fic2 vers fic3
                 $nbl3 = $nbl3 + 1  ;
                 print $fic3  " [fic2] " ." ". $ligne2."\n" ; 
       } ; # on compare en fin de fichier
     }
 else { # criture de fic2 vers fic3
       if (length( $ligne2 ) > 0 ) { 
          # criture de fic2 vers fic3
                 $nbl3 = $nbl3 + 1  ;
                 print $fic3  " [fic2] " ." ". $ligne2."\n" ; 
       } ; # on compare en fin de fichier
       if (length( $ligne1 ) > 0 ) { 
          # criture de fic1 vers fic3
                 $nbl3 = $nbl3 + 1  ;
                 print $fic3  " [fic1] " ." ". $ligne1."\n" ; 
       } ; # on compare en fin de fichier
} ; # comparaison ligne 1 et ligne 2

# s'il reste des lignes dans f1, on recopie f1

while (not $fic1 -> eof() ) { 
     $ligne1  = $fic1 ->getline() ; 
chomp($ligne1 ) ; 
     $nbl1 = $nbl1 + 1  ;
     print $fic3  " [fic1] " ." ". $ligne1."\n" ; 
     $nbl3 = $nbl3 + 1  ;
} ; # lecture sur f1

# s'il reste des lignes dans f2, on recopie f2

while (not $fic2 -> eof() ) { 
     $ligne2  = $fic2 ->getline() ; 
chomp($ligne2 ) ; 
     $nbl2 = $nbl2 + 1  ;
     print $fic3  " [fic2] " ." ". $ligne2."\n" ; 
     $nbl3 = $nbl3 + 1  ;
} ; # lecture sur f1

# fermeture des fichiers

$fic1 ->close() ; 
$fic2 ->close() ; 
$fic3 ->close() ; 

# affichage du nombre de lignes lues et crites :

print "    " ." ". &format( $nbl1 , 4  ) ." ". " lignes lues    sur " ." ". $nomFic1."\n" ; 
print "    " ." ". &format( $nbl2 , 4  ) ." ". " lignes lues    sur " ." ". $nomFic2."\n" ; 
print "    " ." ". &format( $nbl3 , 4  ) ." ". " lignes crites sur " ." ". $nomFic3."\n" ; 

exit(0) ; 

##-#  Ajout de format.pl via le code #> 

sub  format  {
  return( sprintf("%$_[1]d",$_[0]) ) ;
} ; # fin sub format

##-#  Fin d'ajout de format.pl via le code #> 
##-#  Ajout de mot.pl via le code #> 

sub mot { # Retourne le MOT n dans la PHRAse ; seul sparateur : l'espace

  my @TPhraz;
  @TPhraz=split(" ", $_[0]);
  return $TPhraz[$_[1]-1];

} ; # fin de sub mot

##-#  Fin d'ajout de mot.pl via le code #> 
##-#  Ajout de chaineAvant.pl via le code #> 

sub  chaineAvant  {
  my $val ;
  if  ($_[0] le $_[1]) { $val = 1 ; } else { $val = 0 ; } ;
  return( $val ) ;
} ; # fin sub chaineAvant

##-#  Fin d'ajout de chaineAvant.pl via le code #> 

##-#   Fin de traduction pour triFusPerl.pl via de galg -a triFusPerl.alg -o perl
