(* ##-#   Fichier bonjourpascal.pas issu de galg -a bonjourpascal.alg -o pascal *)
(* ##-#  ====================================================================== *)
(* ##-#      03/08/2001 22:42.35 *)

(* ################################################################ *)
(* #                                                              # *)
(* #                                                              # *)
(* #  auteur : (gH)                                               # *)
(* #  bonjour.alg : un algorithme de bonjour consquent.          # *)
(* #                                                              # *)
(* #                                                              # *)
(* ################################################################ *)
(* #                                                              # *)
(* #                                                              # *)
(* #                                                              # *)
(* #      cet algorithme comporte un dialogue o on demande      # *)
(* #      l'utilisateur de donner son nom ;                       # *)
(* #      il affiche ensuite la date et l'heure puis dit au       # *)
(* #      revoir  la personne aprs avoir le nom en majuscules.  # *)
(* #                                                              # *)
(* #                                                              # *)
(* #                                                              # *)
(* ################################################################ *)

PROGRAM bonjourpascal ; 


(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
Uses linux ;

(* ##-#  Ajout de date.pas via le code #>  *)

function date : string ;

 var Year, Month, Day : word ;
     chaineY, chaineM, chaineD : string ;

begin

 GetDate (Year, Month, Day) ;

 str(Year,chaineY) ;
 str(Month,chaineM) ;
 str(Day,chaineD) ;

 if length(chaineD) = 1 then chaineD := '0' + chaineD ;
 if length(chaineM) = 1 then chaineM := '0' + chaineM ;

 date := chaineD+'/'+chaineM+'/'+chaineY ;

end ; (* function date() *)

(* ##-#  Fin d'ajout de date.pas via le code #>  *)
(* ##-#  Ajout de heure.pas via le code #>  *)

function heure : string ;

 Var Hour, Minute, Second : Word ;
     chaineH, chaineM, chaineS : string ;

begin

 GetTime (Hour, Minute, Second);

 str(Hour,chaineH) ;
 str(Minute,chaineM) ;
 str(Second,chaineS) ;

 if length(chaineH) = 1 then chaineH := '0' + chaineH ;
 if length(chaineM) = 1 then chaineM := '0' + chaineM ;
 if length(chaineS) = 1 then chaineS := '0' + chaineS ;

 heure := chaineH+':'+chaineM+'.'+chaineS ;

end ; (* function heure() *)

(* ##-#  Fin d'ajout de heure.pas via le code #>  *)
(* ##-#  Ajout de maju.pas via le code #>  *)

function maju(avant : string ) : string ;

  var ind   : integer ;
      apres : string  ;
      carc  : char    ;
begin

 apres := '' ;
 for ind := 1 to length(avant) do begin
     carc  :=  upcase( avant[ ind ] ) ;
     if carc = '' then carc := 'A' ;
     if carc = '' then carc := 'A' ;
     if carc = '' then carc := 'C' ;
     if carc = '' then carc := 'E' ;
     if carc = '' then carc := 'E' ;
     if carc = '' then carc := 'E' ;
     if carc = '' then carc := 'I' ;
     if carc = '' then carc := 'O' ;
     if carc = '' then carc := 'U' ;
     if carc = '' then carc := 'U' ;
     apres := apres + carc ;
 end ;
 maju := apres ;

end ; (* function maju() *)

(* ##-#  Fin d'ajout de maju.pas via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
var id : string ;

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN

   (* # la demande = une question + une rponse *)

   write( ' Bonjour. Quel est ton nom ? ' ) ; 
   readln( id ) ; 


   (* # ce qu'on fait rpondre par la machine *)

   writeln( ' Le ', date() ,'  ', heure() ,' au revoir ', maju(id)  ) ; 

END.

(* ##-#   Fin de traduction pour bonjourpascal.pas via de galg -a bonjourpascal.alg -o pascal *)
