/* #-#   Fichier triFusC.c issu de galg -a triFusC.alg -o c */
/* #-#  =================================================== */
/* #-#      04/10/2001 15:37.47 */

/*  triFus.alg : trifusion de 2 fichiers dj tris */
/*               auteur -- gH */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de triFusC.inc via le code #>  */

/* # -- triFusC.inc */

chaine nomFic1,
       nomFic2,
       nomFic3,
       ligne1,
       ligne2,
       mot1,
       mot2
       ;

int nbl1,
    nbl2,
    nbl3,
    rc
    ;

FILE *fic1,
     *fic2,
     *fic3   ;

/* ################################################### */

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

/* ################################################### */

int fin_de_fichier(FILE nomf) {
  return 0 ;
} /* fin de fin_de_fichier (hum !) */

/* ################################################### */

char* sousChaine(chaine ancienne, int debut, int longueur) {
chaine nouvelle ;
int ic ;
  strcpy(nouvelle,ancienne) ;
  if (debut<0) { debut = 0 ; } ;
  if (longueur>strlen(ancienne)) { longueur = strlen(ancienne) ; } ;
  nouvelle[longueur] = 0 ;
  for (ic=0;ic<strlen(nouvelle);ic++) {
    nouvelle[ic] = ancienne[debut+ic-1] ;
  } ;
  return(nouvelle) ;
} /* fin de sousChaine */

/* ################################################### */

char* mot(chaine ancienne, int numero) {
chaine PHR ;
chaine lemot ;
chaine sep   ;
int    nb,i,L,debut_mot,fin_mot ;
  strcpy(lemot,ancienne) ;
  strcpy(sep," ") ;
  strcpy(PHR,ancienne) ;
  strcat(PHR,sep) ;
  L    = strlen(PHR) ;
  i    = 0 ;
  nb   = 0 ;
  while ( (i <= L) && (nb < (numero-1)) ) {
     if (PHR[i]==sep[0]) {
        nb = nb + 1 ;
        while ((i <= L ) && (PHR[i]==sep[0])) { i = i + 1 ; } ;
     } ; /*  finsi PHR[i]=sep */
     i = i + 1 ;
  } ; /* fin while (i < L) and ... */
  /* le dbut est donc trouv ; cherchons la fin */
  debut_mot = i ;
  while (i<=L ) {
     if (PHR[i] != sep[0]) {  i = i + 1 ; }
                      else { fin_mot  = i ; i = L + 1 ; }
  } ; /* fin tant que i< L */
  if (fin_mot > debut_mot) { strcpy(lemot,sousChaine(PHR,debut_mot,fin_mot-debut_mot+1)) ; }
                      else { strcpy(lemot,"") ; } ;
printf(" DANS le texte * %20s * le mot %d est **%s ** \n",PHR,numero,lemot) ;
  return(lemot) ;

} /* fin de mot */

/* ################################################### */



/* #-#  Fin d'ajout de triFusC.inc via le code #>  */

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int main() {

/*  nommage des variables pour noms de fichier */

strcpy(nomFic1, "triFus.f1") ;
strcpy(nomFic2, "triFus.f2") ;
strcpy(nomFic3, "triFus.f3") ;

/*  initialisation des nombres de lignes lues et crites */

nbl1 = 0 ;
nbl2 = 0 ;
nbl3 = 0 ;

/*  ouverture des 3 fichiers */

fic1 = fopen(nomFic1,"r") ;
fic2 = fopen(nomFic2,"r") ;
fic3 = fopen(nomFic3,"w") ;

/*  lecture du premier enregistrement sur fic1 */

if ( ! feof(fic1)) {
   /*  lecture possible */
         fgets(ligne1,250,fic1) ;
         ligne1[ strlen(ligne1) -1 ] = 0 ;
         nbl1 = nbl1 + 1 ;
} ; /*  lecture du fic1 */

/*  lecture du premier enregistrement sur fic2 */

if ( ! feof(fic2)) {
   /*  lecture possible */
         fgets(ligne2,250,fic2) ;
         ligne2[ strlen(ligne2) -1 ] = 0 ;
         nbl2 = nbl2 + 1 ;
} ; /*  lecture du fic1 */

/*  boucle de tri-fusion */

while (( ! feof(fic1)) && ( ! feof(fic2))) {
  strcpy(mot1, mot(ligne1, 2) ) ;
  strcpy(mot2, mot(ligne2, 2) ) ;
  if (strncmp( mot1,mot2,20)<=0) {
     /*  criture de fic1 vers fic3 */
            fprintf(fic3,"%s","*  (fic1) ") ;
            fprintf(fic3,"%s",ligne1) ;
            fprintf(fic3,"\n") ;
            nbl3 = nbl3 + 1 ;
            if (( ! feof(fic1))) {
               /*  lecture possible */
                     if (fgets(ligne1,250,fic1)!=0) { ;
                        ligne1[ strlen(ligne1) -1 ] = 0 ;
                        nbl1 = nbl1 + 1 ;
                     } ; /* fin de si */
               } else { strcpy(ligne1,"*") ;
            } ; /*  lecture du fic1 */
     } else { /*  criture de fic2 vers fic3 */
            fprintf(fic3,"%s","** (fic2) ") ;
            fprintf(fic3,"%s",ligne2) ;
            fprintf(fic3,"\n") ;
            nbl3 = nbl3 + 1 ;
            if (( ! feof(fic2))) {
               /*  lecture possible */
                     if (fgets(ligne2,250,fic2)!=0) { ;
                        ligne2[ strlen(ligne2) -1 ] = 0 ;
                        nbl2 = nbl2 + 1 ;
                     } ; /* fin de si */
               } else { strcpy(ligne2,"*") ;
            } ; /*  lecture du fic2 */
  } ; /*  comparaison ligne 1 et ligne 2 */
} ; /*  lecture sur les deux fichiers */

if (!feof(fic1)) {
    /*  criture de fic1 vers fic3 */
    fprintf(fic3,"%s","-  (fic1) ") ;
    fprintf(fic3,"%s",ligne1) ;
    fprintf(fic3,"\n") ;
    nbl3 = nbl3 + 1 ;
}

if (!feof(fic2)) {
    fprintf(fic3,"%s","   (fic2) ") ;
    fprintf(fic3,"%s",ligne2) ;
    fprintf(fic3,"\n") ;
    nbl3 = nbl3 + 1 ;
}

/*  s'il reste des lignes dans f1, on recopie f1 */

while ( ! feof(fic1)) {
     if (fgets(ligne1,250,fic1)!=0) {
        ligne1[ strlen(ligne1) -1 ] = 0 ;
        nbl1 = nbl1 + 1 ;
        fprintf(fic3,"%s","   [fic1] ") ;
        fprintf(fic3,"%s",ligne1) ;
        fprintf(fic3,"\n") ;
        nbl3 = nbl3 + 1 ;
     } ; /*  fin de si */
} ; /*  lecture sur f1 */

/*  s'il reste des lignes dans f2, on recopie f2 */

while ( ! feof(fic2)) {
     if (fgets(ligne2,250,fic2)!=0) {
        ligne2[ strlen(ligne2) -1 ] = 0 ;
        nbl2 = nbl2 + 1 ;
        fprintf(fic3,"%s","   [fic2] ") ;
        fprintf(fic3,"%s",ligne2) ;
        fprintf(fic3,"\n") ;
        nbl3 = nbl3 + 1 ;
     } ; /*  fin de si */
} ; /*  lecture sur f1 */

/*  fermeture des fichiers */

fclose(fic1) ;
fclose(fic2) ;
fclose(fic3) ;

/*  affichage du nombre de lignes lues et crites : */

printf("%s","    ") ;
printf("%s",formatEntier(nbl1, 4)) ;
printf("%s"," lignes lues    sur ") ;
printf("%s",nomFic1) ;
puts("") ;


printf("%s","    ") ;
printf("%s",formatEntier(nbl2, 4)) ;
printf("%s"," lignes lues    sur ") ;
printf("%s",nomFic2) ;
puts("") ;


printf("%s","    ") ;
printf("%s",formatEntier(nbl3, 4)) ;
printf("%s"," lignes crites sur ") ;
printf("%s",nomFic3) ;
puts("") ;

exit(  0 ) ;

return(0);
} /* fin de main */

/* #-#   Fin de traduction pour triFusC.c via de galg -a triFusC.alg -o c */
