// #-#   Fichier triFusCpp.cpp issu de galg -a triFusCpp.alg -o cpp
// #-#  ===========================================================
// #-#      15/10/2001 12:1.34

//  triFus.alg : trifusion de 2 fichiers dj tris
//               auteur -- gH

#include <iostream>
#include <string>
#include <fstream>

 typedef char chaine[250] ;

// #-#  Ajout de triFusCpp.inc via le code #> 

chaine nomFic1,
       nomFic2,
       nomFic3,
       ligne1,
       ligne2,
       mot1,
       mot2
       ;

int nbl1,
    nbl2,
    nbl3,
    rc
    ;

#include <iostream>
#include <string>
#include <fstream>

typedef char chaine[250] ;

// ###############################################################

char* sousChaine(chaine ancienne, int debut, int longueur) {
chaine nouvelle ;
int ic ;
  strcpy(nouvelle,ancienne) ;
  if (debut<0) { debut = 0 ; } ;
  if (longueur>strlen(ancienne)) { longueur = strlen(ancienne) ; } ;
  nouvelle[longueur] = 0 ;
  for (ic=0;ic<strlen(nouvelle);ic++) {
    nouvelle[ic] = ancienne[debut+ic-1] ;
  } ; // fin pour
  return(nouvelle) ;
} /* fin de sousChaine */

// ###############################################################

char* mot(chaine ancienne, int numero) {
chaine PHR ;
chaine lemot ;
chaine motr ;
chaine sep   ;
int    nb,i,L,debut_mot,fin_mot,lng_mot ;
  strcpy(lemot,ancienne) ;
  strcpy(sep," ") ;
  strcpy(PHR,ancienne) ;
  strcat(PHR,sep) ;
  L    = strlen(PHR) ;
  i    = 0 ;
  nb   = 0 ;
  while ( (i < L) && (nb < (numero-1)) ) {
     if (PHR[i]==sep[0]) {
        nb = nb + 1 ;
        while ((i < L ) && (PHR[i]==sep[0])) { i = i + 1 ; } ;
     } ; /*  finsi PHR[i]=sep */
     i = i + 1 ;
  } ; /* fin while (i < L) and ... */
  /* le dbut est donc trouv ; cherchons la fin */
  debut_mot = i ;
  while (i<L ) {
     if (PHR[i] != sep[0]) {  i = i + 1 ; }
                      else { fin_mot  = i ; i = L + 1 ; }
  } ; /* fin tant que i< L */
  lng_mot = fin_mot-debut_mot+1 ;
  strcpy(motr,ancienne) ;
  if (fin_mot > debut_mot) { strcpy(motr,sousChaine(PHR,debut_mot,lng_mot)) ; } ;
  if (fin_mot > debut_mot) { strcpy(lemot,motr) ; }
                      else { strcpy(lemot,"") ; } ;
  return(lemot) ;

} /* fin de mot */


// ###############################################################


// #-#  Fin d'ajout de triFusCpp.inc via le code #> 

// #-#  La ligne suivante provient d'un ajout via le code #: 
int main() {

//  nommage des variables pour noms de fichier

strcpy(nomFic1, "triFus.f1") ; 
strcpy(nomFic2, "triFus.f2") ; 
strcpy(nomFic3, "triFus.f3") ; 

//  initialisation des nombres de lignes lues et crites

nbl1 = 0 ;
nbl2 = 0 ;
nbl3 = 0 ;

//  ouverture des 3 fichiers

ifstream fic1(nomFic1) ;
ifstream fic2(nomFic2) ;
ofstream fic3(nomFic3) ;

//  lecture du premier enregistrement sur fic1

if ( ! fic1.eof() ) { 
   //  lecture possible
         fic1.getline(ligne1,250) ;
         nbl1 = nbl1 + 1 ;
} ; //  lecture du fic1

//  lecture du premier enregistrement sur fic2

if ( ! fic2.eof() ) { 
   //  lecture possible
         fic2.getline(ligne2,250) ;
         nbl2 = nbl2 + 1 ;
} ; //  lecture du fic2

//  boucle de tri-fusion

while (( ! fic1.eof() ) && ( ! fic2.eof() )) { 

  strcpy(mot1, mot(ligne1, 2)) ; 
  strcpy(mot2, mot(ligne2, 2)) ; 

  if (strncmp(mot1, mot2, 20) < 0) { 
     //  criture de fic1 vers fic3
            if (strlen(ligne1) > 0) { 
               
                     fic3 << " (fic1) " << ligne1 << endl ; 
                     nbl3 = nbl3 + 1 ;
            } ; //  sur longueur
            if ( ! fic1.eof() ) { 
               //  on a une ligne de plus
                     fic1.getline(ligne1,250) ;
            } ; //  lecture
            if (strlen(ligne1) > 0) { 
               
                     nbl1 = nbl1 + 1 ;
               } else { 
                     strcpy(ligne1, "") ; 
            } ; //  lecture du fic1
     } else { //  criture de fic2 vers fic3
            if (strlen(ligne2) > 0) { 
               
               fic3 << " (fic2) " << ligne2 << endl ; 
               nbl3 = nbl3 + 1 ;
            } ; //  sur longueur
            if ( ! fic2.eof() ) { 
               //  on a une ligne de plus
                     fic2.getline(ligne2,250) ;
            } ; 
            if (strlen(ligne1) > 0) { 
                  
                     nbl2 = nbl2 + 1 ;
               } else { 
                     strcpy(ligne2, "") ; 
            } ; //  lecture du fic2
  } ; //  comparaison ligne 1 et ligne 2
} ; //  lecture sur les deux fichiers

//  un des deux lignes n'a pas t recopie, donc :

if ( ! fic1.eof()  && strlen(ligne1) > 0) { 
   //  criture de fic1 vers fic3
                     fic3 << " (fic1) " << ligne1 << endl ; 
                     nbl3 = nbl3 + 1 ;
} ; //  on compare en fin de fichier

if ( ! fic2.eof()  && strlen(ligne2) > 0) { 
   //  criture de fic2 vers fic3
                     fic3 << " (fic2) " << ligne2 << endl ; 
                     nbl3 = nbl3 + 1 ;
} ; //  on compare en fin de fichier

//  s'il reste des lignes dans f1, on recopie f1

while ( ! fic1.eof() ) { 
            fic1.getline(ligne1,250) ;
            if (strlen(ligne1) > 0) { 
               
                 nbl1 = nbl1 + 1 ;
                 fic3 << " [fic1] " << ligne1 << endl ; 
                 nbl3 = nbl3 + 1 ;
            } ; //  sur longueur
} ; //  lecture sur f1

//  s'il reste des lignes dans f2, on recopie f2

while ( ! fic2.eof() ) { 
            fic2.getline(ligne2,250) ;
            if (strlen(ligne2) > 0) { 
               
                 nbl2 = nbl2 + 1 ;
                 fic3 << " [fic2] " << ligne2 << endl ; 
                 nbl3 = nbl3 + 1 ;
            } ; //  sur longueur
} ; //  lecture sur f1

//  fermeture des fichiers

fic1.close() ;
fic2.close() ;
fic3.close() ;

//  affichage du nombre de lignes lues et crites :

cout << "    " << nbl1 << " lignes lues    sur " << nomFic1 << endl ; 
cout << "    " << nbl2 << " lignes lues    sur " << nomFic2 << endl ; 
cout << "    " << nbl3 << " lignes crites sur " << nomFic3 << endl ; 

exit( 0 ) ; 

return(0);
} /* fin de main */

// #-#   Fin de traduction pour triFusCpp.cpp via de galg -a triFusCpp.alg -o cpp
