// ##-#   Fichier rchbdb.prg issu de galg -a rchbdb.alg -o dbase
// ##-#  =======================================================
// ##-#      02/08/2001 19:34.42

// ##########################################################
// #                                                        #
// #                                                        #
// #  rchbrut.alg : brutesearch, auteur (gH)                #
// #                                                        #
// #                                                        #
// ##########################################################
// #                                                        #
// # source : Algorithms, second edition                    #
// #          pages 279, 280                                #
// #          R. Sedgewick, Addison-Wesley 1988             #
// #                                                        #
// ##########################################################
// #                                                        #
// #                                                        #
// #  recherche "brute" du tableau P dans le tableau A      #
// #  (en anglais : P pour pattern, A pour array)           #
// #  les variables sont renommes tabP et tabA             #
// #  pour plus de lisibilit.   le tableau tabP contient   #
// #  les codes ascii de la phrase                          #
// #                                                        #
// #      "A STRING SEARCHING EXAMPLE CONSISTING OF..."     #
// #                                                        #
// #  et le tableau tabA ceux du mot   "STING"              #
// #                                                        #
// #                                                        #
// ##########################################################


store "STING" to chP 
store "A STRING SEARCHING EXAMPLE CONSISTING OF..." to chA 

// # conversion des chaines en tableaux

store  len(chP) to M 

// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare tabP[ M ]

for ind := 1 to M 
  store  asc( substr(chP ,  ind ,  1)) to tabP[ ind ] 
next // # ind de1a longueur(chP)

store  len(chA) to N 

// ##-#  La ligne suivante provient d'un ajout via le code #: 
declare tabA[ N ]
print " N vaut ",N 
for ind := 1 to N 
  store  asc( substr(chA ,  ind ,  1)) to tabA[ ind ] 
next // # ind de1a longueur(chA)


// # algorithme de recherche

store 1 to i 
store 1 to j 


// ## il n'y pas de structure REPETER en Dbase alors on
// ## remplace la boucle REPETER par une boucle TANT QUE
// ## rpter

do while ((j <= M)  .and.   (i <= N)) 

  if tabA[ i ] = tabP[ j ] 
       store i + 1 to i 
           store j + 1 to j 
      else  
           store i - j + 2 to i 
           store 1 to j 
  endif // # tabA[i] = tabP[i]

// ## jusqu' ((j>M) ou (i>N))
enddo // # ((j<=M) et (i<=N))


// # affichage du rsultat

if j > M 
     print chP," vue dans ",chA,"  partir de la position ",(i - M) 
    else  print chP," non vue dans ",chA 
endif // # j>M


// # dtail des tableaux (on suppose M < N)

print " Elment tableau P  tableau A " 

for ind := 1 to N 
   if (ind <= M) 
        
           store  concatene( str(tabP[ ind ] ,  8) ,  " ") to milieu 
           store  concatene(milieu ,   substr(chP ,  ind ,  1)) to milieu 
       else  
           store  replicate(" " ,  10) to milieu 
   endif // # (ind<=M)
   print  str(ind ,  3)," : ",milieu, str(tabA[ ind ] ,  8), substr(chA ,  ind ,  1) 
next // # ind de1a N

// #  il arrive que maxrun n'affiche pas la dernire ligne du buffer, d'o :
// ##-#  La ligne suivante provient d'un ajout via le code #: 
? " "
// ##-#  Ajout de concatene.prg via le code #> 

function concatene
  parameters debut , fin
return debut + fin

// ##-#  Fin d'ajout de concatene.prg via le code #> 

// ##-#   Fin de traduction pour rchbdb.prg via de galg -a rchbdb.alg -o dbase
