(* ##-#   Fichier tabmultpascal.pas issu de galg -a tabmultpascal.alg -o pascal *)
(* ##-#  ====================================================================== *)
(* ##-#      03/08/2001 23:59.06 *)

(* ##################################################### *)
(* #                                                   # *)
(* # tabmult.alg -- un exemple simple d'algorithme :   # *)
(* #                la table de multiplication         # *)
(* #                                                   # *)
(* #  auteur : gh                                      # *)
(* #                                                   # *)
(* ##################################################### *)
(* #                                                   # *)
(* #  on demande  l'utilisateur un nombre entier et   # *)
(* #  on le relance tant que le nombre n'est pas       # *)
(* #  entier.                                          # *)
(* #                                                   # *)
(* #  lorsque le nombre est entier, on afiche sa       # *)
(* #  table avec cadrage des units sous les units,   # *)
(* #  des dizaines sous les dizaines etc.              # *)
(* #                                                   # *)
(* ##################################################### *)

PROGRAM tabmultpascal ; 


(* ##-#  Ajout de format.pas via le code #>  *)

function format( nombre : integer ; longueur : integer ) : string ;
  var chaine : string ;
begin
  str(nombre:longueur,chaine) ;
  format := chaine ;
end ;

(* ##-#  Fin d'ajout de format.pas via le code #>  *)
(* ##-#  Ajout de entier.pas via le code #>  *)

function entier( chaine : string ) : boolean ;
 var nbMauvaisCar : integer ;
     ind          : integer ;
begin
 nbMauvaisCar := 0 ;
 for ind := 1 to length( chaine ) do begin
     if (chaine[ ind ] < '0') or (chaine[ ind ] > '9') then nbMauvaisCar := nbMauvaisCar + 1 ;
 end ;
 entier := nbMauvaisCar = 0 ;
end ;

(* ##-#  Fin d'ajout de entier.pas via le code #>  *)
(* ##-#  Ajout de valeur.pas via le code #>  *)

function valeur( chaine : string) : real ;


 var rc : integer ;
     nombre : real ;

begin

 val(chaine,nombre,rc) ;
 if rc=0 then valeur := nombre
         else valeur := -999.99 ;

end ; (* function valeur() *)

(* ##-#  Fin d'ajout de valeur.pas via le code #>  *)

(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
var
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
chNbChoisi : string  ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
nbChoisi   : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
indb       : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
produit    : integer ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
find       : string  ;
(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
fpro       : string  ;


(* ##-#  La ligne suivante provient d'un ajout via le code #:  *)
BEGIN

(* # demande initiale *)

write( ' Donner un entier ' ) ; 
readln( chNbChoisi ) ; 

(* # relance ventuelle *)

while ( (  not   entier(chNbChoisi) ) ) do begin 
    write( ' nombre incorrect. Redonner un nombre ENTIER ' ) ; 
    readln( chNbChoisi ) ; 
end ; (* # nombre invalide *)


(* # boucle d'affichage *)


writeln( ' le nombre est ',chNbChoisi ) ; 

nbChoisi :=  trunc( valeur(chNbChoisi) )  ;
writeln( ' Table de ',nbChoisi ) ; 
for indb := 1 to 10 do begin 
    produit := nbChoisi  *  indb ;
    find :=  format(indb ,  2)  ;
    fpro :=  format(produit ,  5)  ;
    writeln( find,' fois ',nbChoisi,' = ',fpro ) ; 
end ; (* # indb de1a 10 *)

END.

(* ##-#   Fin de traduction pour tabmultpascal.pas via de galg -a tabmultpascal.alg -o pascal *)
