##-#   Fichier maxoccmonoTcl.tcl issu de galg -a maxoccmonoTcl.alg -o tcl
##-#  ===================================================================
##-#      31/07/2001 23:40.22

###############################################
#                                              #
#                                              #
#   dtermination du maximum dans un tableau   #
#   et comptage du nombre d'occurences de ce   #
#   maximum  en une seule boucle               #
#                                              #
#                                              #
################################################
#                                              #
# auteur : gh                                  #
#                                              #
################################################

##-#  Ajout de entierAuHasard.tcl via le code #> 

proc  entierAuHasard  { vmin vmax } {
  return [ expr int($vmin + ($vmax-$vmin)*rand()) ]
} ; # fin proc entierAuHasard

##-#  Fin d'ajout de entierAuHasard.tcl via le code #> 
##-#  Ajout de _format.tcl via le code #> 

proc  _format  { nombre longueur } {
  set chformat [append "%" $longueur "d"]
  return [format %$chformat $nombre]
} ; # fin proc _format


##-#  Fin d'ajout de _format.tcl via le code #> 

# initialisation du tableau avec 15 lments
# entiers entre 10 et 20

set nbElt [ expr "15 " ]
for  { set indb 1  }    { $indb  <= $nbElt  }   { set indb [ incr indb ] }  { 
     set monT($indb)  [ expr "[entierAuHasard 10 20 ] " ]
} ; # indb de1a nbElt-1


# initialisation de la valeur du maximum (valMax)
# et de son nombre d'occurences (nbMax)

set valMax [ expr "$monT($nbElt) " ]
set nbMax [ expr "1 " ]


# on parcourt alors le tableau
# sans utiliser le dernier lment dja comptabilis

for  { set indb 1  }    { $indb  <= $nbElt  }   { set indb [ incr indb ] }  { 
     set eltCourant [ expr "$monT($indb) " ]
     if { $eltCourant > $valMax  } { 
        # nouveau maximum local
              set valMax [ expr "$eltCourant " ]
              set nbMax [ expr "1 " ]
        } else { 
              if { $eltCourant == $valMax  } { 
                 # une fois de plus le maximum
                       set nbMax [ expr "$nbMax + 1 " ]
              } ; # nouvelle occurence du maximum
     } ; # nouveau maximum
} ; # indb de1a 10


# affichage de fin

puts " Le maximum dans le tableau est :   $valMax  "
puts " et il apparait   $nbMax  fois.  "
puts " Pour vrification, voici les lments du tableau :  "

for  { set indb 1  }    { $indb  <= $nbElt  }   { set indb [ incr indb ] }  { 
    puts "    lment    [_format $indb 3 ]  :  [_format $monT($indb) 4 ]  "
} ; # indb de1a nbElt-1

##-#   Fin de traduction pour maxoccmonoTcl.tcl via de galg -a maxoccmonoTcl.alg -o tcl
