/* #-#   Fichier maxoccmonoC.c issu de galg -a maxoccmonoC.alg -o c */
/* #-#  =========================================================== */
/* #-#      19/09/2001 12:17.53 */

/* ############################################## */
/*                                               # */
/*                                               # */
/*    dtermination du maximum dans un tableau   # */
/*    et comptage du nombre d'occurences de ce   # */
/*    maximum  en une seule boucle               # */
/*                                               # */
/*                                               # */
/* ############################################### */
/*                                               # */
/*  auteur : gh                                  # */
/*                                               # */
/* ############################################### */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de ecrireEntier.c via le code #>  */

void ecrireEntier(float f) {
  printf("%d",(int) f) ;
  return ;
} /* fin de ecrireEntier */

/* #-#  Fin d'ajout de ecrireEntier.c via le code #>  */
/* #-#  Ajout de entierAuHasard.c via le code #>  */

int entierAuHasard(int vmin, int vmax) {
  double res = 0  ;
  res = (double) rand() / ((double)RAND_MAX + 1) * (vmax-vmin+1) ;
  return( (int) vmin + res ) ;
} /* fin de entierAuHasard) */

/* #-#  Fin d'ajout de entierAuHasard.c via le code #>  */
/* #-#  Ajout de formatEntier.c via le code #>  */

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

/* #-#  Fin d'ajout de formatEntier.c via le code #>  */

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int main(int argc, char *argv[]) {

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int nbElt      = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int indb       = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int valMax     = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int nbMax      = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int eltCourant = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int monT[50] ;

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
srand( time(NULL) ) ;

/*  initialisation du tableau avec 15 lments */
/*  entiers entre 10 et 20 */

nbElt = 15 ;
for(indb=1; indb<=nbElt; indb++) { 
     monT[indb] = entierAuHasard(10, 20) ;
} ; /*  indb de1a nbElt-1 */


/*  initialisation de la valeur du maximum (valMax) */
/*  et de son nombre d'occurences (nbMax) */

valMax = monT[nbElt] ;
nbMax = 1 ;


/*  on parcourt alors le tableau */
/*  sans utiliser le dernier lment dja comptabilis */

for(indb=1; indb<=nbElt-1; indb++) { 
     eltCourant = monT[indb] ;
     if (eltCourant > valMax) { 
        /*  nouveau maximum local */
              valMax = eltCourant ;
              nbMax = 1 ;
        } else { 
              if (eltCourant == valMax) { 
                 /*  une fois de plus le maximum */
                       nbMax = nbMax + 1 ;
              } ; /*  nouvelle occurence du maximum */
     } ; /*  nouveau maximum */
} ; /*  indb de1a 10 */


/*  affichage de fin */

printf("%s"," Le maximum dans le tableau est : ") ;

ecrireEntier(valMax) ; 
printf("%s","") ;
puts("") ;


printf("%s"," et il apparait ") ;

ecrireEntier(nbMax) ; 
printf("%s"," fois.") ;
puts("") ;


printf("%s"," Pour vrification, voici les lments du tableau : ") ;
puts("") ;


for(indb=1; indb<=nbElt; indb++) { 
    printf("%s","    lment  ") ;

    printf("%s",formatEntier(indb, 3)) ;

    printf("%s","  : ") ;

    printf("%s",formatEntier(monT[indb], 4)) ;
puts("") ;

} ; /*  indb de1a nbElt-1 */
return(0);
} /* fin de main */ 

/* #-#   Fin de traduction pour maxoccmonoC.c via de galg -a maxoccmonoC.alg -o c */
