/* #-#   Fichier tabmultC.c issu de galg -a tabmultC.alg -o c */
/* #-#  ===================================================== */
/* #-#      19/09/2001 12:21.03 */

/* #################################################### */
/*                                                    # */
/*  tabmult.alg -- un exemple simple d'algorithme :   # */
/*                 la table de multiplication         # */
/*                                                    # */
/*   auteur : gh                                      # */
/*                                                    # */
/* #################################################### */
/*                                                    # */
/*   on demande  l'utilisateur un nombre entier et   # */
/*   on le relance tant que le nombre n'est pas       # */
/*   entier.                                          # */
/*                                                    # */
/*   lorsque le nombre est entier, on afiche sa       # */
/*   table avec cadrage des units sous les units,   # */
/*   des dizaines sous les dizaines etc.              # */
/*                                                    # */
/* #################################################### */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

 typedef char chaine[250] ;

/* #-#  Ajout de ecrireEntier.c via le code #>  */

void ecrireEntier(float f) {
  printf("%d",(int) f) ;
  return ;
} /* fin de ecrireEntier */

/* #-#  Fin d'ajout de ecrireEntier.c via le code #>  */
/* #-#  Ajout de formatEntier.c via le code #>  */

char *formatEntier(int nombre,int longueur) {

  int      next ;
  char     qbuf[100] ;
  char     qbuf2[100] ;
  register int r, k ;
  int      flag = 0 ;

  next = 0 ;
  if (nombre <  0) { qbuf[next++] = '-' ; nombre = -nombre ; }
  if (nombre == 0) { qbuf[next++] = '0' ;   } else {
      k = 10000 ;
      while (k > 0) {
         r = nombre / k ;
         if (flag || r > 0) {
               qbuf[next++] = '0' + r ;
               flag = 1 ;
         } ; /* finde si flag ok */
         nombre -= r * k ;
         k       = k / 10 ;
        } ; /* fin de tant que k > 0 */
  } ; /* fin de si nombre non nul */
  qbuf[next] = 0 ;
  while (strlen(qbuf)<longueur) {
    strcpy(qbuf2," ")  ;
    strcat(qbuf2,qbuf) ;
    strcpy(qbuf,qbuf2) ;
  ; } ; /* fin de tant que chaine trop courte */

  return(qbuf);

} /* fin de formatEntier */

/* #-#  Fin d'ajout de formatEntier.c via le code #>  */
/* #-#  Ajout de affecterChaine.c via le code #>  */

void affecterChaine(chaine nouvelle, chaine ancienne) {
  strcpy(nouvelle,ancienne) ;
  return ;
} /* fin de affecterChaine */

/* #-#  Fin d'ajout de affecterChaine.c via le code #>  */
/* #-#  Ajout de entier.c via le code #>  */

int entier(chaine chen) {
  int res = 0 ; /* rsultat */
  int ic  = 0 ;
  int nb  = 0 ;
  /* on vrifie qu'il n'y a que des chiffres ou "return" */
  while (ic<strlen(chen)) {
    if ( (!isdigit(chen[ic])) && (chen[ic]!=10) ) { res++ ; } ;
    ic++ ;
  } ; /* fin tant que sur ic */
  /* puis on vrifie que le nombre n'est pas trop grand */
  if (res==0) {
     nb = atoi( chen ) ;
     if (nb>3276) { res++ ; } ;
  } ; /* fin de si res= */
  return( res==0 ) ;
} /* fin de entier */

/* #-#  Fin d'ajout de entier.c via le code #>  */

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int main(int argc, char *argv[]) {

/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int nbChoisi = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int produit  = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
int indb     = 0 ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
chaine find ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
chaine fpro ;
/* #-#  La ligne suivante provient d'un ajout via le code #:  */
chaine chNbChoisi ;

/*  demande initiale */

printf("%s"," Donner un entier < 3276 : ") ;

fgets(chNbChoisi,250,stdin) ;

/*  relance ventuelle */

while (( ! entier(chNbChoisi))) { 
    printf("%s","") ;
puts("") ;

    printf("%s"," nombre incorrect. Redonner un nombre ENTIER < 3276 : ") ;

    fgets(chNbChoisi,250,stdin) ;
} ; /*  nombre invalide */

nbChoisi = atoi(chNbChoisi) ;

/*  boucle d'affichage */

printf("%s"," Table de ") ;

ecrireEntier(nbChoisi) ; 
printf("%s","") ;
puts("") ;



for(indb=1; indb<=10; indb++) { 
    produit = nbChoisi * indb ;
    affecterChaine(find, formatEntier(indb, 2)) ; 
    affecterChaine(fpro, formatEntier(produit, 5)) ; 
    printf("%s",find) ;

    printf("%s"," fois ") ;

    ecrireEntier(nbChoisi) ; 
    printf("%s"," = ") ;

    printf("%s",fpro) ;
puts("") ;

} ; /*  indb de1a 10 */
return(0);
} /* fin de main */ 

/* #-#   Fin de traduction pour tabmultC.c via de galg -a tabmultC.alg -o c */
