//#-#   Fichier tabmultJava.java issu de galg -a tabmultJava.alg -o java
//#-#  =================================================================
//#-#      13/09/2001 18:2.02

//####################################################
//                                                   #
// tabmult.alg -- un exemple simple d'algorithme :   #
//                la table de multiplication         #
//                                                   #
//  auteur : gh                                      #
//                                                   #
//####################################################
//                                                   #
//  on demande  l'utilisateur un nombre entier et   #
//  on le relance tant que le nombre n'est pas       #
//  entier.                                          #
//                                                   #
//  lorsque le nombre est entier, on afiche sa       #
//  table avec cadrage des units sous les units,   #
//  des dizaines sous les dizaines etc.              #
//                                                   #
//####################################################

//#-#  La ligne suivante provient d'un ajout via le code #: 
import java.io.* ;
class tabmultJava { 


//#-#  Ajout de valeurEntiere.java via le code #> 

static int valeurEntiere(String chen) {

  int valeur_entiere = 100 ;

  try {  valeur_entiere = Integer.valueOf(chen).intValue() ; }
  catch (NumberFormatException erreurConv) {
         System.out.println(" Erreur de conversion en entier ") ;
         System.exit(-1) ;
  } // fin de catch

  return valeur_entiere ;

} // fin de valeurEntiere

//#-#  Fin d'ajout de valeurEntiere.java via le code #> 
//#-#  Ajout de format.java via le code #> 

public static String format(int nombre, int longueur) {

  String chen = Integer.toString(nombre) ;
  while (chen.length() < longueur) { chen = " " + chen ; } ;
  return chen ;

} // fin de format

//#-#  Fin d'ajout de format.java via le code #> 
//#-#  Ajout de entier.java via le code #> 

public static boolean entier(String chen) {
  boolean resultat = false ;
  int nb_entier = -1 ;
  try {  nb_entier = Integer.valueOf(chen).intValue() ;
     resultat = true ;
  } // fin de try
  catch (NumberFormatException erreurConv) {
     resultat = false ;
  } // fin de catch
   return resultat ;
} // fin de entier

//#-#  Fin d'ajout de entier.java via le code #> 

//#-#  La ligne suivante provient d'un ajout via le code #: 
public static void main(String args[]) {
//#-#  La ligne suivante provient d'un ajout via le code #: 
// dbut de la mthode main()# demande initiale


//#-#  La ligne suivante provient d'un ajout via le code #: 
String chNbChoisi = ""  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int      nbChoisi = 0   ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
int      produit  = 0   ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
String   find     = ""  ;
//#-#  La ligne suivante provient d'un ajout via le code #: 
String   fpro     = ""  ;

 System.out.print(" Donner un entier ") ;

   System.out.flush() ;
   try { 
     BufferedReader clavier = 
        new BufferedReader(new InputStreamReader(System.in)) ;
     chNbChoisi = clavier.readLine() ; 
   } // fin de try  ; }
   catch (IOException erreurES) { System.out.println(erreurES.getMessage()); }


 System.out.println("merci") ;


// relance ventuelle

while (( ! entier(chNbChoisi))) { 
     System.out.print(" nombre incorrect. Redonner un nombre ENTIER ") ;

       System.out.flush() ;
   try { 
     BufferedReader clavier = 
        new BufferedReader(new InputStreamReader(System.in)) ;
     chNbChoisi = clavier.readLine() ; 
   } // fin de try  ; }
   catch (IOException erreurES) { System.out.println(erreurES.getMessage()); }

} ; // nombre invalide


// boucle d'affichage

nbChoisi = valeurEntiere(chNbChoisi) ;
 System.out.println(" Table de "+nbChoisi) ;

for (int indb=1; indb<=10; indb++) { 
    produit = nbChoisi * indb ;
    find = format(indb, 2) ;
    fpro = format(produit, 5) ;
     System.out.println(find+" fois "+nbChoisi+" = "+fpro) ;

} ; // indb de1a 10
} // fin de la mthode main()
} // fin de la classe tabmultJava 

//#-#   Fin de traduction pour tabmultJava.java via de galg -a tabmultJava.alg -o java
