##-#   Fichier tabmultPerl.pl issu de galg -a tabmultPerl.alg -o perl
##-#  ===============================================================
##-#      29/07/2001 20:5.31

#####################################################
#                                                   #
# tabmult.alg -- un exemple simple d'algorithme :   #
#                la table de multiplication         #
#                                                   #
#  auteur : gh                                      #
#                                                   #
#####################################################
#                                                   #
#  on demande  l'utilisateur un nombre entier et   #
#  on le relance tant que le nombre n'est pas       #
#  entier.                                          #
#                                                   #
#  lorsque le nombre est entier, on afiche sa       #
#  table avec cadrage des units sous les units,   #
#  des dizaines sous les dizaines etc.              #
#                                                   #
#####################################################



# demande initiale

print " Donner un entier "."\n" ; 
chomp($nbChoisi=<STDIN>) ; 


# relance ventuelle

while (( not entier( $nbChoisi )) ) { 
    print " nombre incorrect. Redonner un nombre ENTIER "."\n" ; 
    chomp($nbChoisi=<STDIN>) ; 
} ; # nombre invalide


# boucle d'affichage

print " Table de " ." ". $nbChoisi."\n" ; 
for ( $indb = 1  ;  $indb <= 10  ; $indb++ ) { 
    $produit = $nbChoisi * $indb  ; 
    $find = &format( $indb , 2 , 0 )  ; 
    $fpro = &format( $produit , 5 , 0 )  ; 
    print $find ." ". " fois " ." ". $nbChoisi ." ". " = " ." ". $fpro."\n" ; 
} ; # indb de1a 10

##-#  Ajout de entier.pl via le code #> 

sub  entier  {

  # renvoie "vrai" si le paramtre est un entier ventuellement sign

  my $parm_entier = $_[0] ;
  return $parm_entier =~ /^[+-]?\d+$/ ;

} ; # fin sub entier

##-#  Fin d'ajout de entier.pl via le code #> 
##-#  Ajout de format.pl via le code #> 

sub  format  {
  return( sprintf("%$_[1]d",$_[0]) ) ;
} ; # fin sub format

##-#  Fin d'ajout de format.pl via le code #> 

##-#   Fin de traduction pour tabmultPerl.pl via de galg -a tabmultPerl.alg -o perl
